#!/usr/bin/php5
<?php

// tplgen.php

$opts = array(
	'open'  => '<%',
	'close' => '%>',
	'echo_open' => 'echo(',
	'echo_close' => ');',
	'trim'  => true
);

if (count($_SERVER['argv']) < 2) {
	die('Usage: '.$_SERVER['argv'][0].' filename.tpl'."\n");
}

$parts = preg_split(
	'/'.$opts['open'].'(.+?)'.$opts['close'].'/s',
	@file_get_contents($_SERVER['argv'][1]),
	-1,
	PREG_SPLIT_DELIM_CAPTURE
);
if (! count($parts)) die('Error');

for ($i = 0, $e = count($parts); $i < $e; $i++) {
	if ($i % 2) {
		if ($parts[$i][0] === '=') {
			echo $opts['echo_open'].substr($parts[$i], 1).$opts['echo_close']."\n";
		} else {
			echo ltrim($parts[$i])."\n";
		}
	
	} else { 
		$part = $opts['trim'] ? trim($parts[$i]) : $parts[$i];
		$part_len = strlen($part);
		if ($part_len > 40) {
			
			echo $opts['echo_open'].'"'.implode("\" \\\n".str_repeat(" ", strlen($opts['echo_open']))."\"", array_map('cesc', str_split($part, 40))).'"'.$opts['echo_close']."\n";
			
			
		} else if ($part_len) {
			echo $opts['echo_open'].'"'.cesc($part).'"'.$opts['echo_close']."\n";
		}
	
	}
}

function cesc($sz) {
	return str_replace(array("\n", "\r", '"'), array("\\n", "\\r", '\\"'), $sz);
}
